## python-memray 1.17.0+dfsg

=== Makefile ===
PYTHON ?= python
NPM ?= npm
CLANG_FORMAT ?= clang-format

# Doc generation variables
UPSTREAM_GIT_REMOTE ?= origin
DOCSBUILDDIR := docs/_build
HTMLDIR := $(DOCSBUILDDIR)/html
PIP_INSTALL=$(PYTHON) -m pip install

reporters_path := ./src/memray/reporters
js_files := $(wildcard $(reporters_path)/assets/*.js)
generated_js_files := \
    $(reporters_path)/templates/assets/flamegraph_common.js \
    $(reporters_path)/templates/assets/flamegraph.js \
    $(reporters_path)/templates/assets/temporal_flamegraph.js \
    $(reporters_path)/templates/assets/table.js
cpp_files := $(shell find src/memray/_memray -name \*.cpp -o -name \*.h)

# Use this to inject arbitrary commands before the make targets (e.g. docker)
ENV :=

.PHONY: build
build: build-js build-ext  ## (default) Build package extensions and assets in-place

.PHONY: build-ext
build-ext:  ## Build package extensions in-place
	$(PYTHON) setup.py build_ext --inplace

$(reporters_path)/templates/assets/%.js: $(reporters_path)/assets/%.js
	$(NPM) install
	$(NPM) run-script build
	touch $(generated_js_files)

.PHONY: build-js
build-js: $(generated_js_files)  ## Build package assets in-place

.PHONY: dist
dist:  ## Generate Python distribution files
	$(PYTHON) -m build --wheel .

.PHONY: install-sdist
install-sdist: dist  ## Install from source distribution
	$(ENV) $(PIP_INSTALL) $(wildcard dist/*.tar.gz)

.PHONY: test-install
test-install: build-js ## Install with test dependencies
	$(ENV) CYTHON_TEST_MACROS=1 $(PIP_INSTALL) -e .[test]

.PHONY: dev-install
dev-install: build-js ## Install with dev dependencies
	$(ENV) CYTHON_TEST_MACROS=1 $(PIP_INSTALL) -e .[dev]

.PHONY: check
check: check-python check-js  ## Run all the tests

.PHONY: check-python  ## Run the Python tests
check-python:
	$(PYTHON) -m pytest -vvv --log-cli-level=info -s --color=yes $(PYTEST_ARGS) tests

.PHONY: check-js  ## Run the Javascript tests
check-js:
	$(NPM) install jest --save-dev
	$(NPM) run-script test

.PHONY: pycoverage
pycoverage:  ## Run the test suite, with Python code coverage
	$(PYTHON) -m pytest \
		-vvv \
		--log-cli-level=info \
		-s \
		--color=yes \
		--cov=memray \
		--cov=tests \
		--cov-config=pyproject.toml \
		--cov-report=term \
		--cov-fail-under=90 \
		--cov-append $(PYTEST_ARGS) \
		tests
	$(PYTHON) -m coverage lcov -i -o pycoverage.lcov
	if [ -z "$$SKIP_COVERAGE_HTML" ]; then \
		genhtml *coverage.lcov  --branch-coverage --output-directory memray-coverage $(GENHTMLOPTS); \
	fi

.PHONY: valgrind
valgrind:  ## Run valgrind, with the correct configuration
	PYTHONMALLOC=malloc valgrind \
		--suppressions=./valgrind.supp \
		--leak-check=full \
		--show-leak-kinds=definite \
		--error-exitcode=1 \
		--gen-suppressions=all \
		$(PYTHON) -m pytest tests -m valgrind -v

.PHONY: helgrind
helgrind:  ## Run helgrind, with the correct configuration
	PYTHONMALLOC=malloc valgrind  \
		--suppressions=./valgrind.supp \
		--tool=helgrind \
		--error-exitcode=1 \
		--gen-suppressions=all \
		$(PYTHON) -m pytest tests -m valgrind -v

.PHONY: ccoverage
ccoverage:  ## Run the test suite, with C++ code coverage
	$(MAKE) clean
	CFLAGS="$(CFLAGS) -O0 -pg --coverage" $(MAKE) build
	$(MAKE) check
	gcov -i build/*/src/memray/_memray -i -d
	lcov --capture --directory .  --output-file cppcoverage.lcov
	lcov --extract cppcoverage.lcov '*/src/memray/_memray/*' --output-file cppcoverage.lcov
	genhtml *coverage.lcov --branch-coverage --output-directory memray-coverage
	find . | grep -E '(\.gcda|\.gcno|\.gcov\.json\.gz)' | xargs rm -rf

.PHONY: format
format:  ## Autoformat all files
	$(PYTHON) -m pre_commit run --all-files

.PHONY: lint
lint:  ## Lint all files
	$(PYTHON) -m pre_commit run --all-files
	$(PYTHON) -m mypy -p memray --strict --ignore-missing-imports
	$(PYTHON) -m mypy tests --ignore-missing-imports

.PHONY: docs
docs:  ## Generate documentation
	$(MAKE) -C docs clean
	$(MAKE) -C docs html
	$(MAKE) -C docs man

.PHONY: docs-live
docs-live:  ## Serve documentation on localhost:8000, with live-reload
	$(MAKE) -C docs clean
	$(MAKE) -C docs livehtml

.PHONY: gh-pages
gh-pages:  ## Publish documentation on GitHub Pages
	$(eval GIT_REMOTE := $(shell git remote get-url $(UPSTREAM_GIT_REMOTE)))
	$(eval COMMIT_HASH := $(shell git rev-parse HEAD))
	touch $(HTMLDIR)/.nojekyll
	@echo -n "Documentation ready, push to $(GIT_REMOTE)? [Y/n] " && read ans && [ $${ans:-Y} == Y ]
	git init $(HTMLDIR)
	GIT_DIR=$(HTMLDIR)/.git GIT_WORK_TREE=$(HTMLDIR) git add -A
	GIT_DIR=$(HTMLDIR)/.git git commit -m "Documentation for commit $(COMMIT_HASH)"
	GIT_DIR=$(HTMLDIR)/.git git push $(GIT_REMOTE) HEAD:gh-pages --force
	rm -rf $(HTMLDIR)/.git


.PHONY: clean
clean:  ## Clean any built/generated artifacts
	find . | grep -E '(\.o|\.gcda|\.gcno|\.gcov\.json\.gz)' | xargs rm -rf
	find . | grep -E '(__pycache__|\.pyc|\.pyo)' | xargs rm -rf
	rm -rf build
	rm -f src/memray/_test_utils.*.so
	rm -f src/memray/_memray.*.so
	rm -f src/memray/_inject.*.so
	rm -f src/memray/_memray.cpp
	rm -rf memray-coverage
	rm -rf node_modules
	rm -f cppcoverage.lcov

.PHONY: bump_version
bump_version:
	bump2version $(RELEASE)
	$(eval NEW_VERSION := $(shell bump2version \
	                                --allow-dirty \
	                                --dry-run \
	                                --list $(RELEASE) \
	                                | tail -1 \
	                                | sed s,"^.*=",,))
	git commit --amend --no-edit

.PHONY: gen_news
gen_news:
	$(eval CURRENT_VERSION := $(shell bump2version \
	                            --allow-dirty \
	                            --dry-run \
	                            --list $(RELEASE) \
	                            | grep current_version \
	                            | sed s,"^.*=",,))
	$(PYEXEC) towncrier build --version $(CURRENT_VERSION) --name memray
	git commit --amend --no-edit

.PHONY: release-patch
release-patch: RELEASE=patch
release-patch: bump_version gen_news  ## Prepare patch version release

.PHONY: release-minor
release-minor: RELEASE=minor
release-minor: bump_version gen_news  ## Prepare minor version release

.PHONY: release-major
release-major: RELEASE=major
release-major: bump_version gen_news ## Prepare major version release

.PHONY: benchmark
benchmark:  ## Benchmark the head of current branch
	$(PYTHON) -m asv run
	$(PYTHON) -m asv publish

.PHONY: benchmark_new
benchmark_new:  ## Benchmark all commits since the latest benchmarked on this machine
	$(PYTHON) -m asv run NEW
	$(PYTHON) -m asv publish

.PHONY: help
help:  ## Print this message
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

=== benchmarks/requirements.txt ===
pyperf
matplotlib
seaborn
numpy

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

SPHINXAUTOBUILD = sphinx-autobuild

# You can set these variables from the command line.
SPHINXOPTS    = -n -W --keep-going
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = memray
SOURCEDIR     = .
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -W -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: man
man:
	$(SPHINXBUILD) -b man -D exclude_patterns= $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The man pages are in $(BUILDDIR)/man."

.PHONY: livehtml
livehtml:
	$(SPHINXAUTOBUILD) -a $(ALLSPHINXOPTS) $(BUILDDIR)/html

=== docs/examples/nbody/requirements.txt ===
numpy
rebound

## python-memray 1.13.0+dfsg

=== debian/changelog ===
python-memray (1.13.0+dfsg-1) unstable; urgency=medium

  * Updated to new upstream version 1.13.0.
  * Updated old patches to fit new upstream version.
  * Added new patches to fix tests in Python 3.12 and
    to fix the docs.
  * d/control: Added libunwind-dev to B-Depends.
  * d/rules: Revised pybuild test args to fir new
    upstream version + enabled memray binary.
  * Added man pages for memray binary.

 -- Yogeswaran Umasankar <kd8mbd@gmail.com>  Sat, 22 Jun 2024 00:05:00 +0000

python-memray (1.11.0+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1067871)

 -- Yogeswaran Umasankar <kd8mbd@gmail.com>  Mon, 27 May 2024 16:50:00 +0000

=== debian/control ===
Source: python-memray
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Yogeswaran Umasankar <kd8mbd@gmail.com>,
Homepage: https://github.com/bloomberg/memray
Vcs-Git: https://salsa.debian.org/python-team/packages/python-memray.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/python-memray
Section: python
Priority: optional
Build-Depends:
 black,
 check-manifest,
 cython3,
 debhelper-compat (= 13),
 dh-sequence-python3,
 furo <!nodoc>,
 libdebuginfod-dev,
 libjs-bootstrap <!nodoc>,
 libjs-d3 <!nodoc>,
 libjs-jquery <!nodoc>,
 libjs-jquery-datatables <!nodoc>,
 libjs-lodash <!nodoc>,
 libjs-popper.js <!nodoc>,
 liblz4-dev,
 libunwind-dev,
 python3-all,
 python3-dev,
 python3-flake8,
 python3-greenlet <!nocheck>,
 python3-ipython,
 python3-isort,
 python3-jinja2,
 python3-mypy,
 python3-pkgconfig,
 python3-pytest <!nocheck>,
 python3-pytest-cov <!nocheck>,
 python3-rich,
 python3-setuptools,
 python3-sphinx <!nodoc>,
 python3-sphinx-argparse <!nodoc>,
 python3-textual,
 python3-typing-extensions,
 python3.12-dev,
 towncrier <!nodoc>,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Testsuite: autopkgtest-pkg-pybuild

Package: python3-memray
Architecture: any
Depends:
 libjs-bootstrap,
 libjs-d3,
 libjs-jquery,
 libjs-jquery-datatables,
 libjs-lodash,
 libjs-popper.js,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Memory profiler for Python applications
 Memray is a memory profiler for Python. It can track memory
 allocations in Python code, in native extension modules,
 and in the Python interpreter itself. It can generate several
 different types of reports to help you analyze the captured
 memory usage data. While commonly used as a CLI tool, it
 can also be used as a library to perform more fine-grained
 profiling tasks.

Package: python-memray-doc
Architecture: all
Section: doc
Depends:
 libjs-bootstrap,
 libjs-jquery,
 ${misc:Depends},
 ${sphinxdoc:Depends},
Multi-Arch: foreign
Description: Documentation for python-memray
 Memray is a memory profiler for Python. It can track memory
 allocations in Python code, in native extension modules,
 and in the Python interpreter itself. It can generate several
 different types of reports to help you analyze the captured
 memory usage data. While commonly used as a CLI tool, it
 can also be used as a library to perform more fine-grained
 profiling tasks.
 .
 This package contains documentation for memray.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=memray
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Disabled tests that has ModuleNotFoundError for import memray, need further investigation.
# 3rd from the last is timeout failure.
# Last two are 10s timeout failure in build i386.
export PYBUILD_TEST_ARGS = \
	-v -k 'not test_sys_manipulations_when_running_script \
	and not test_suppressing_sys_manipulations_when_running_script[-I] \
	and not test_suppressing_sys_manipulations_when_running_script[-P] \
	and not test_suppressing_sys_manipulations_when_running_module[-I] \
	and not test_suppressing_sys_manipulations_when_running_module[-P] \
	and not test_sys_manipulations_when_running_cmd \
	and not test_suppressing_sys_manipulations_when_running_cmd[-I] \
	and not test_suppressing_sys_manipulations_when_running_cmd[-P] \
	and not test_multithreaded_extension_with_native_tracking \
	and not test_simple_call_chain_with_native_tracking \
	and not test_inlined_call_chain_with_native_tracking \
	and not test_deep_call_chain_with_native_tracking \
	and not test_hybrid_stack_in_pure_python \
	and not test_hybrid_stack_in_pure_python_with_callbacks \
	and not test_hybrid_stack_of_allocations_inside_ceval \
	and not test_hybrid_stack_in_recursive_python_c_call \
	and not test_hybrid_stack_in_a_thread \
	and not test_hybrid_stack_of_python_thread_starts_with_native_frames \
	and not test_allocations_with_multiprocessing \
	and not test_allocations_with_multiprocessing_following_fork \
	and not test_pymalloc_allocations_after_fork \
	and not test_stack_cleanup_after_fork \
	and not test_aggregation_same_python_stack_but_different_native_stack[ALL_ALLOCATIONS] \
	and not test_aggregation_same_python_stack_but_different_native_stack[AGGREGATED_ALLOCATIONS] \
	and not test_reading_allocations_while_reading_stack_traces \
	and not test_live_tracking_waits_for_client \
	and not test_live_tracking'

%:
	dh $@ --with sphinxdoc --buildsystem=pybuild

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--warnings=9

override_dh_auto_install:
	dh_auto_install
	# Strip unneeded symbols and notes from shared libraries
	find debian/python3-memray -name "*.so*" -exec strip --strip-unneeded --remove-section=.note.gnu.build-id {} +

override_dh_install:
	dh_install
	mkdir -p debian/python3-memray/usr/lib/python3/dist-packages/
	mv debian/python3-memray/usr/lib/python3.12/dist-packages/memray-*.egg-info debian/python3-memray/usr/lib/python3/dist-packages/
	rm -rf debian/python3-memray/usr/lib/python3.11/dist-packages/memray-*.egg-info
	rm -f debian/python3-memray/usr/bin/memray3.11
	rm -f debian/python3-memray/usr/bin/memray3.12

override_dh_installdocs:
	https_proxy='127.0.0.1:9' sphinx-build -b html docs build/sphinx/html
	dh_installdocs -ppython-memray-doc --doc-main-package=python-memray-doc build/sphinx/html
	dh_installdocs

## python-memray 1.13.3+dfsg

=== debian/changelog ===
python-memray (1.13.3+dfsg-1) unstable; urgency=medium

  * New upstream version 1.13.3.
  * Rename d/python-memray-doc.doc to d/python-memray-doc.docs.

 -- Yogeswaran Umasankar <yogu@debian.org>  Mon, 08 Jul 2024 13:30:00 +0000

python-memray (1.13.2+dfsg-1) unstable; urgency=medium

  * Updated to new upstream version 1.13.2.
  * d/control: added python3.11-dev to Build Depends +
    updated Uploaders.
  * d/copyright: updated 2019-2020 Red Hat, Inc.
    copyright file name + updated debian/* changelog.
  * d/rules: remove duplicate files in docs and create
    symbolic links.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 28 Jun 2024 09:00:00 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: python-memray
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders:
- Yogeswaran Umasankar <kd8mbd@gmail.com>,
+ Yogeswaran Umasankar <yogu@debian.org>,
 Homepage: https://github.com/bloomberg/memray
 Vcs-Git: https://salsa.debian.org/python-team/packages/python-memray.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/python-memray
@@ -25,6 +25,7 @@
  libunwind-dev,
  python3-all,
  python3-dev,
+ python3.11-dev,
  python3-flake8,
  python3-greenlet <!nocheck>,
  python3-ipython,

=== debian/rules ===
--- 
+++ 
@@ -58,5 +58,71 @@
 
 override_dh_installdocs:
 	https_proxy='127.0.0.1:9' sphinx-build -b html docs build/sphinx/html
+
+	# Remove duplicate files
+	rm -f build/sphinx/html/_static/images/codespaces_testing_tab.png
+	rm -f build/sphinx/html/_static/images/complex_example.png
+	rm -f build/sphinx/html/_static/images/exercise1_flamegraph.png
+	rm -f build/sphinx/html/_static/images/exercise2_flamegraph.png
+	rm -f build/sphinx/html/_static/images/exercise3_flamegraph_basic.png
+	rm -f build/sphinx/html/_static/images/exercise3_flamegraph_native.png
+	rm -f build/sphinx/html/_static/images/filter_thread_dropdown.png
+	rm -f build/sphinx/html/_static/images/gprof2dot_example.png
+	rm -f build/sphinx/html/_static/images/icicle_flame_toggle.png
+	rm -f build/sphinx/html/_static/images/inverted_flame_graph_for_inverted_example.png
+	rm -f build/sphinx/html/_static/images/live_different_thread.png
+	rm -f build/sphinx/html/_static/images/live_disconnected.png
+	rm -f build/sphinx/html/_static/images/live_running.png
+	rm -f build/sphinx/html/_static/images/logo.png
+	rm -f build/sphinx/html/_static/logo.png
+	rm -f build/sphinx/html/_static/images/mandelbrot_operation_native.png
+	rm -f build/sphinx/html/_static/images/mandelbrot_operation_non_native.png
+	rm -f build/sphinx/html/_static/images/native_mode_debug.png
+	rm -f build/sphinx/html/_static/images/native_mode_no_debug.png
+	rm -f build/sphinx/html/_static/images/non_relevant_checkbox.png
+	rm -f build/sphinx/html/_static/images/normal_flamegraph_for_inverted_example.png
+	rm -f build/sphinx/html/_static/images/output.png
+	rm -f build/sphinx/html/_static/images/plot_default_options.png
+	rm -f build/sphinx/html/_static/images/plot_native.png
+	rm -f build/sphinx/html/_static/images/plot_python_allocators.png
+	rm -f build/sphinx/html/_static/images/plot_python_allocators_native.png
+	rm -f build/sphinx/html/_static/images/ports_tab.png
+	rm -f build/sphinx/html/_static/images/pymalloc.png
+	rm -f build/sphinx/html/_static/images/pytest_cli_output.png
+	rm -f build/sphinx/html/_static/images/quotes.png
+	rm -f build/sphinx/html/_static/images/rss_vs_heap.png
+	rm -f build/sphinx/html/_static/images/rss_vs_heap_no_free.png
+	rm -f build/sphinx/html/_static/images/simple_example.png
+	rm -f build/sphinx/html/_static/images/stats_example.png
+	rm -f build/sphinx/html/_static/images/summary_example.png
+	rm -f build/sphinx/html/_static/images/table_example.png
+	rm -f build/sphinx/html/_static/images/temporal_high_water_mark_controls.png
+	rm -f build/sphinx/html/_static/images/tree_example.png
+
+	# Create symlinks
+	ln -sf ../../../_images/codespaces_testing_tab.png build/sphinx/html/_static/images/codespaces_testing_tab.png
+	ln -sf ../../../_images/complex_example.png build/sphinx/html/_static/images/complex_example.png
+	ln -sf ../../../_images/exercise1_flamegraph.png build/sphinx/html/_static/images/exercise1_flamegraph.png
+	ln -sf ../../../_images/exercise2_flamegraph.png build/sphinx/html/_static/images/exercise2_flamegraph.png
+	ln -sf ../../../_images/exercise3_flamegraph_basic.png build/sphinx/html/_static/images/exercise3_flamegraph_basic.png
+	ln -sf ../../../_images/exercise3_flamegraph_native.png build/sphinx/html/_static/images/exercise3_flamegraph_native.png
+	ln -sf ../../../_images/filter_thread_dropdown.png build/sphinx/html/_static/images/filter_thread_dropdown.png
+	ln -sf ../../../_images/gprof2dot_example.png build/sphinx/html/_static/images/gprof2dot_example.png
+	ln -sf ../../../_images/icicle_flame_toggle.png build/sphinx/html/_static/images/icicle_flame_toggle.png
+	ln -sf ../../../_images/inverted_flame_graph_for_inverted_example.png build/sphinx/html/_static/images/inverted_flame_graph_for_inverted_example.png
+	ln -sf ../../../_images/live_different_thread.png build/sphinx/html/_static/images/live_different_thread.png
+	ln -sf ../../../_images/live_disconnected.png build/sphinx/html/_static/images/live_disconnected.png
+	ln -sf ../../../_images/live_running.png build/sphinx/html/_static/images/live_running.png
+	ln -sf ../../../_images/logo.png build/sphinx/html/_static/images/logo.png
+	ln -sf ../../../logo.png build/sphinx/html/_static/logo.png
+	ln -sf ../../../_images/mandelbrot_operation_native.png build/sphinx/html/_static/images/mandelbrot_operation_native.png
+	ln -sf ../../../_images/mandelbrot_operation_non_native.png build/sphinx/html/_static/images/mandelbrot_operation_non_native.png
+	ln -sf ../../../_images/native_mode_debug.png build/sphinx/html/_static/images/native_mode_debug.png
+	ln -sf ../../../_images/native_mode_no_debug.png build/sphinx/html/_static/images/native_mode_no_debug.png
+	ln -sf ../../../_images/non_relevant_checkbox.png build/sphinx/html/_static/images/non_relevant_checkbox.png
+	ln -sf ../../../_images/normal_flamegraph_for_inverted_example.png build/sphinx/html/_static/images/normal_flamegraph_for_inverted_example.png
+	ln -sf ../../../_images/output.png build/sphinx/html/_static/images/output.png
+	ln -sf ../../../_images/plot_default_options.png
+
 	dh_installdocs -ppython-memray-doc --doc-main-package=python-memray-doc build/sphinx/html
 	dh_installdocs

## python-memray 1.13.4+dfsg

=== debian/changelog ===
python-memray (1.13.4+dfsg-4) unstable; urgency=medium

  * Skip test_tracking.py failing autopkgtests in armhf.

 -- Yogeswaran Umasankar <yogu@debian.org>  Wed, 14 Aug 2024 15:00:00 +0000

python-memray (1.13.4+dfsg-3) unstable; urgency=medium

  * Update the list of tests to skip in d/rules and d/tests/runtests.

 -- Yogeswaran Umasankar <yogu@debian.org>  Wed, 14 Aug 2024 04:00:00 +0000

python-memray (1.13.4+dfsg-2) unstable; urgency=medium

  * Add d/tests to fix test failures in various ARCH.
  * d/rules: define and skip failed tests in each ARCH.
  * d/control: remove testsuite.
  * d/copyright: update to GPL-2+, GPL-3+ and LGPL-2+.

 -- Yogeswaran Umasankar <yogu@debian.org>  Sun, 11 Aug 2024 01:00:00 +0000

python-memray (1.13.4+dfsg-1) unstable; urgency=medium

  * New upstream version 1.13.4.
  * Disable tests in ARCH with timeout and segfault.

 -- Yogeswaran Umasankar <yogu@debian.org>  Mon, 22 Jul 2024 01:40:00 +0000

python-memray (1.13.3+dfsg-2) unstable; urgency=medium

  * d/control: replace python3.*-dev with python3-all-dev + added
    pybuild-plugin-pyproject in Build-Depends. (Closes: #1076202)
  * d/rules: updated override_dh_install for pybuild-plugin-pyproject.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 12 Jul 2024 15:30:00 +0000

## python-memray 1.14.0+dfsg

=== debian/changelog ===
python-memray (1.14.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.14.0.
  * Update patches to fit new upstream version + update email ID in
    patches.
  * d/copyright: update to fit new upstream version.

 -- Yogeswaran Umasankar <yogu@debian.org>  Wed, 11 Sep 2024 21:15:00 +0000

=== debian/control ===
--- 
+++ 
@@ -23,9 +23,9 @@
  libjs-popper.js <!nodoc>,
  liblz4-dev,
  libunwind-dev,
+ pybuild-plugin-pyproject,
  python3-all,
- python3-dev,
- python3.11-dev,
+ python3-all-dev,
  python3-flake8,
  python3-greenlet <!nocheck>,
  python3-ipython,
@@ -41,11 +41,9 @@
  python3-sphinx-argparse <!nodoc>,
  python3-textual,
  python3-typing-extensions,
- python3.12-dev,
  towncrier <!nodoc>,
 Rules-Requires-Root: no
 Standards-Version: 4.7.0
-Testsuite: autopkgtest-pkg-pybuild
 
 Package: python3-memray
 Architecture: any

## python-memray 1.15.0+dfsg

=== debian/changelog ===
python-memray (1.15.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.15.0.
  * d/control: update libjs-bootstrap to libjs-bootstrap5 in Depends.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 06 Dec 2024 19:16:12 +0000

python-memray (1.14.0+dfsg-2) unstable; urgency=medium

  * d/control: bump libjs-bootstrap4 to libjs-bootstrap5
    in B-Depends. (Closes: #1088430)

 -- Yogeswaran Umasankar <yogu@debian.org>  Mon, 02 Dec 2024 18:23:58 +0000

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  dh-sequence-python3,
  furo <!nodoc>,
  libdebuginfod-dev,
- libjs-bootstrap <!nodoc>,
+ libjs-bootstrap5 <!nodoc>,
  libjs-d3 <!nodoc>,
  libjs-jquery <!nodoc>,
  libjs-jquery-datatables <!nodoc>,
@@ -48,7 +48,7 @@
 Package: python3-memray
 Architecture: any
 Depends:
- libjs-bootstrap,
+ libjs-bootstrap5,
  libjs-d3,
  libjs-jquery,
  libjs-jquery-datatables,
@@ -72,7 +72,7 @@
 Architecture: all
 Section: doc
 Depends:
- libjs-bootstrap,
+ libjs-bootstrap5,
  libjs-jquery,
  ${misc:Depends},
  ${sphinxdoc:Depends},

=== debian/rules ===
--- 
+++ 
@@ -4,38 +4,6 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
-
-# Disabled tests that has ModuleNotFoundError for import memray, need further investigation.
-# 3rd from the last is timeout failure.
-# Last two are 10s timeout failure in build i386.
-export PYBUILD_TEST_ARGS = \
-	-v -k 'not test_sys_manipulations_when_running_script \
-	and not test_suppressing_sys_manipulations_when_running_script[-I] \
-	and not test_suppressing_sys_manipulations_when_running_script[-P] \
-	and not test_suppressing_sys_manipulations_when_running_module[-I] \
-	and not test_suppressing_sys_manipulations_when_running_module[-P] \
-	and not test_sys_manipulations_when_running_cmd \
-	and not test_suppressing_sys_manipulations_when_running_cmd[-I] \
-	and not test_suppressing_sys_manipulations_when_running_cmd[-P] \
-	and not test_multithreaded_extension_with_native_tracking \
-	and not test_simple_call_chain_with_native_tracking \
-	and not test_inlined_call_chain_with_native_tracking \
-	and not test_deep_call_chain_with_native_tracking \
-	and not test_hybrid_stack_in_pure_python \
-	and not test_hybrid_stack_in_pure_python_with_callbacks \
-	and not test_hybrid_stack_of_allocations_inside_ceval \
-	and not test_hybrid_stack_in_recursive_python_c_call \
-	and not test_hybrid_stack_in_a_thread \
-	and not test_hybrid_stack_of_python_thread_starts_with_native_frames \
-	and not test_allocations_with_multiprocessing \
-	and not test_allocations_with_multiprocessing_following_fork \
-	and not test_pymalloc_allocations_after_fork \
-	and not test_stack_cleanup_after_fork \
-	and not test_aggregation_same_python_stack_but_different_native_stack[ALL_ALLOCATIONS] \
-	and not test_aggregation_same_python_stack_but_different_native_stack[AGGREGATED_ALLOCATIONS] \
-	and not test_reading_allocations_while_reading_stack_traces \
-	and not test_live_tracking_waits_for_client \
-	and not test_live_tracking'
 
 %:
 	dh $@ --with sphinxdoc --buildsystem=pybuild
@@ -48,13 +16,85 @@
 	# Strip unneeded symbols and notes from shared libraries
 	find debian/python3-memray -name "*.so*" -exec strip --strip-unneeded --remove-section=.note.gnu.build-id {} +
 
+# Skip failing tests in each ARCH
+export FILES_ARGS=--ignore=tests/integration/test_main.py \
+--ignore=tests/integration/test_native_tracking.py
+
+export TIMEOUT_ARGS=and not test_reading_allocations_while_reading_stack_traces \
+and not test_live_tracking_waits_for_client \
+and not test_live_tracking \
+and not test_live_client_exits_properly_on_sigint_before_connecting \
+and not test_multithreaded_extension \
+and not test_misbehaving_extension \
+and not test_extension_that_uses_pygilstate_ensure \
+and not test_native_dlopen \
+and not test_valloc_at_thread_exit \
+and not test_valloc_at_thread_exit_in_subprocess \
+and not test_dlopen_with_rpath
+
+export ARM64_ARGS="${FILES_ARGS} \
+-v -k 'not test_aggregation_same_python_stack_but_different_native_stack[ALL_ALLOCATIONS] \
+and not test_aggregation_same_python_stack_but_different_native_stack[AGGREGATED_ALLOCATIONS] \
+and not test_allocations_with_multiprocessing \
+and not test_pymalloc_allocations_after_fork \
+and not test_stack_cleanup_after_fork \
+${TIMEOUT_ARGS}'"
+
+export ARMHF_ARGS="${FILES_ARGS} \
+--ignore=tests/integration/test_tracing.py \
+--ignore=tests/integration/test_tracking.py \
+-v -k 'not test_thread_name \
+and not test_setting_python_thread_name \
+and not test_successful_parse_of_aggregated_capture_file \
+${TIMEOUT_ARGS}'"
+
+export ARMEL_ARGS="${FILES_ARGS} \
+--ignore=tests/integration/test_tracing.py \
+-v -k 'not test_thread_name \
+and not test_setting_python_thread_name \
+and not test_aggregation_same_python_stack_and_same_native_stack[ALL_ALLOCATIONS] \
+and not test_aggregation_same_python_stack_and_same_native_stack[AGGREGATED_ALLOCATIONS] \
+and not test_aggregation_same_python_stack_but_different_native_stack[ALL_ALLOCATIONS] \
+and not test_aggregation_same_python_stack_but_different_native_stack[AGGREGATED_ALLOCATIONS] \
+${TIMEOUT_ARGS}'"
+
+export S390X_ARGS="${FILES_ARGS} \
+-v -k 'not test_aggregation_same_python_stack_and_same_native_stack[ALL_ALLOCATIONS] \
+and not test_aggregation_same_python_stack_and_same_native_stack[AGGREGATED_ALLOCATIONS] \
+and not test_large_number_of_frame_pops_between_subsequent_allocations \
+and not test_aggregation_same_python_stack_but_different_native_stack[ALL_ALLOCATIONS] \
+and not test_aggregation_same_python_stack_but_different_native_stack[AGGREGATED_ALLOCATIONS] \
+and not test_inverted_very_deep_call_is_limited \
+and not test_rejects_different_header_version \
+and not test_allocations_with_multiprocessing \
+${TIMEOUT_ARGS}'"
+
+export AMD64_OTHERS_ARGS="${FILES_ARGS} \
+-v -k 'not test_reading_allocations_while_reading_stack_traces \
+and not test_live_tracking_waits_for_client \
+and not test_live_tracking \
+${TIMEOUT_ARGS}'"
+
+override_dh_auto_test:
+ifneq (,$(filter arm64,$(DEB_BUILD_ARCH)))
+	PYBUILD_TEST_ARGS=$(ARM64_ARGS) dh_auto_test
+else ifneq (,$(filter armhf,$(DEB_BUILD_ARCH)))
+	PYBUILD_TEST_ARGS=$(ARMHF_ARGS) dh_auto_test
+else ifneq (,$(filter armel,$(DEB_BUILD_ARCH)))
+	PYBUILD_TEST_ARGS=$(ARMEL_ARGS) dh_auto_test
+else ifneq (,$(filter s390x,$(DEB_BUILD_ARCH)))
+	PYBUILD_TEST_ARGS=$(S390X_ARGS) dh_auto_test
+else ifneq (,$(filter amd64 i386 ppc64el riscv64,$(DEB_BUILD_ARCH)))
+	PYBUILD_TEST_ARGS=$(AMD64_OTHERS_ARGS) dh_auto_test
+else ifneq (,$(filter mips64el ppc64 loong64 sh4,$(DEB_BUILD_ARCH)))
+	@echo "Skip tests in $(DEB_BUILD_ARCH)"
+else
+	dh_auto_test
+endif
+
 override_dh_install:
 	dh_install
-	mkdir -p debian/python3-memray/usr/lib/python3/dist-packages/
-	mv debian/python3-memray/usr/lib/python3.12/dist-packages/memray-*.egg-info debian/python3-memray/usr/lib/python3/dist-packages/
-	rm -rf debian/python3-memray/usr/lib/python3.11/dist-packages/memray-*.egg-info
-	rm -f debian/python3-memray/usr/bin/memray3.11
-	rm -f debian/python3-memray/usr/bin/memray3.12
+	rm -f debian/python3-memray/usr/bin/memray3.*
 
 override_dh_installdocs:
 	https_proxy='127.0.0.1:9' sphinx-build -b html docs build/sphinx/html
@@ -113,16 +153,3 @@
 	ln -sf ../../../_images/live_different_thread.png build/sphinx/html/_static/images/live_different_thread.png
 	ln -sf ../../../_images/live_disconnected.png build/sphinx/html/_static/images/live_disconnected.png
 	ln -sf ../../../_images/live_running.png build/sphinx/html/_static/images/live_running.png
-	ln -sf ../../../_images/logo.png build/sphinx/html/_static/images/logo.png
-	ln -sf ../../../logo.png build/sphinx/html/_static/logo.png
-	ln -sf ../../../_images/mandelbrot_operation_native.png build/sphinx/html/_static/images/mandelbrot_operation_native.png
-	ln -sf ../../../_images/mandelbrot_operation_non_native.png build/sphinx/html/_static/images/mandelbrot_operation_non_native.png
-	ln -sf ../../../_images/native_mode_debug.png build/sphinx/html/_static/images/native_mode_debug.png
-	ln -sf ../../../_images/native_mode_no_debug.png build/sphinx/html/_static/images/native_mode_no_debug.png
-	ln -sf ../../../_images/non_relevant_checkbox.png build/sphinx/html/_static/images/non_relevant_checkbox.png
-	ln -sf ../../../_images/normal_flamegraph_for_inverted_example.png build/sphinx/html/_static/images/normal_flamegraph_for_inverted_example.png
-	ln -sf ../../../_images/output.png build/sphinx/html/_static/images/output.png
-	ln -sf ../../../_images/plot_default_options.png
-
-	dh_installdocs -ppython-memray-doc --doc-main-package=python-memray-doc build/sphinx/html
-	dh_installdocs

## python-memray 1.17.0+dfsg

=== debian/changelog ===
python-memray (1.17.0+dfsg-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 31 Oct 2025 14:51:55 +0000

python-memray (1.17.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.17.0.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 04 Apr 2025 19:28:26 +0000

python-memray (1.16.0+dfsg-2) unstable; urgency=medium

  * d/rules & d/tests/runtests: skip failing tests in riscv64.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 04 Apr 2025 01:42:36 +0000

python-memray (1.16.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.16.0.
  * d/control: bump Standards-Version to 4.7.2.
  * d/copyright:
    - Update debian/* copyright year.
    - Fix fsf address in GPL-2+, GPL-3+ and LGPL-3+.
  * Add d/salsa-ci.yml.

 -- Yogeswaran Umasankar <yogu@debian.org>  Sun, 30 Mar 2025 00:26:59 +0000

=== debian/control ===
--- 
+++ 
@@ -43,7 +43,7 @@
  python3-typing-extensions,
  towncrier <!nodoc>,
 Rules-Requires-Root: no
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 
 Package: python3-memray
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -73,6 +73,12 @@
 -v -k 'not test_reading_allocations_while_reading_stack_traces \
 and not test_live_tracking_waits_for_client \
 and not test_live_tracking \
+and not test_munmap_multiple_mmaps_multiple_munmaps[ALL_ALLOCATIONS] \
+and not test_munmap_multiple_mmaps_multiple_munmaps[AGGREGATED_ALLOCATIONS] \
+and not test_basic_attach[gdb] \
+and not test_aggregated_attach[gdb] \
+and not test_attach_time[gdb] \
+and not test_detach_without_attach[gdb] \
 ${TIMEOUT_ARGS}'"
 
 override_dh_auto_test:
@@ -150,6 +156,3 @@
 	ln -sf ../../../_images/gprof2dot_example.png build/sphinx/html/_static/images/gprof2dot_example.png
 	ln -sf ../../../_images/icicle_flame_toggle.png build/sphinx/html/_static/images/icicle_flame_toggle.png
 	ln -sf ../../../_images/inverted_flame_graph_for_inverted_example.png build/sphinx/html/_static/images/inverted_flame_graph_for_inverted_example.png
-	ln -sf ../../../_images/live_different_thread.png build/sphinx/html/_static/images/live_different_thread.png
-	ln -sf ../../../_images/live_disconnected.png build/sphinx/html/_static/images/live_disconnected.png
-	ln -sf ../../../_images/live_running.png build/sphinx/html/_static/images/live_running.png

=== debian/tests/control ===
Tests: runtests
Depends:
 black,
 check-manifest,
 cython3,
 dh-sequence-python3,
 libdebuginfod-dev,
 liblz4-dev,
 libunwind-dev,
 pybuild-plugin-pyproject,
 python3-all,
 python3-all-dev,
 python3-flake8,
 python3-greenlet,
 python3-ipython,
 python3-isort,
 python3-jinja2,
 python3-mypy,
 python3-pkgconfig,
 python3-pytest,
 python3-pytest-cov,
 python3-rich,
 python3-setuptools,
 python3-textual,
 python3-typing-extensions,
 @,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=dversionmangle=auto,repacksuffix=+dfsg \
https://github.com/bloomberg/memray/tags .*/v(\d\S+)\.tar\.gz
